#include <avr/io.h>

#define BAUD 9600
#include <util/setbaud.h>

#define getbit(reg,bit) ((reg) & (1 << (bit) ))


int main() {
    /*=======init USART======*/

    UBRRH=UBRRH_VALUE;    //set baud rate via setbaud.h
    UBRRL=UBRRL_VALUE;    
    
#if USE_2X
    UCSRA |= (1 << U2X); //moar setbaud magic
#else
    UCSRA &= ~(1 << U2X);
#endif

    UCSRB = (1 << TXEN) | (1 << RXEN); /*enable the thing! also, UCSRB has interrupts:
                                        RXCIE - rx complete
                                        TXCIE - tx complete
                                        UDRIE - tx buffer empty (can write moar)*/
    UCSRC = (1 << UCSZ1) | (1 << UCSZ0); //8 bit; USBS=0 -> 1 stop bit; 
    
    /*======end init USART======*/
    DDRB = 0xff; //show the sent/received bytes
    PORTB = 0xaa; //indicates that init went well
    uint8_t c;

    for(c=1; c>0; ++c) { //greet our master
        while ( !getbit(UCSRA, UDRE) ) {;}
        UDR = c;
        PORTB = c;
    }
    while(1) {
        while ( !getbit(UCSRA, RXC) ) {;} //wait for a character
        c = UDR; //get it
        PORTB = c;
        while ( ! getbit(UCSRA, UDRE) ) {;} //wait for opportunity to transmit
        UDR = c; //send it back
    }
}